#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3300eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 3300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3300eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight33004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight33004xi = {
                1:'-1010x-495y-3102z',
                2:'-103x-2193y-2463z',
                3:'-103x-2522y-2125z',
                4:'-1045x-1030y-2955z',
                5:'-1056x-2448y-1943z',
                6:'-1063x-454y-3090z',
                7:'-1071x-2131y-2280z',
                8:'-1084x-3105y-263z',
                9:'-1114x-408y-3079z',
                10:'-1120x-993y-2940z',
                11:'-1163x-358y-3067z',
                12:'-1192x-2406y-1917z',
                13:'-1193x-2091y-2256z',
                14:'-1193x-951y-2925z',
                15:'-1210x-304y-3054z',
                16:'-123x-1097y-3215z',
                17:'-1246x-3046y-230z',
                18:'-1254x-246y-3042z',
                19:'-1265x-905y-2910z',
                20:'-1296x-185y-3029z',
                21:'-130x-569y-3247z',
                22:'-1313x-2045y-2231z',
                23:'-1325x-2357y-1890z',
                24:'-1334x-119y-3015z',
                25:'-1335x-853y-2894z',
                26:'-1403x-796y-2878z',
                27:'-1405x-2979y-197z',
                28:'-1431x-1991y-2207z',
                29:'-1457x-2301y-1862z',
                30:'-1468x-734y-2862z',
                31:'-1531x-668y-2845z',
                32:'-1547x-1931y-2182z',
                33:'-1560x-2903y-164z',
                34:'-1586x-2236y-1835z',
                35:'-1590x-597y-2828z',
                36:'-1646x-521y-2811z',
                37:'-1660x-1864y-2158z',
                38:'-168x-593y-3241z',
                39:'-1699x-441y-2794z',
                40:'-1710x-2818y-131z',
                41:'-1712x-2164y-1808z',
                42:'-1771x-1789y-2132z',
                43:'-180x-1088y-3110z',
                44:'-1835x-2085y-1780z',
                45:'-1856x-2726y-98z',
                46:'-1878x-1708y-2107z',
                47:'-1954x-1999y-1752z',
                48:'-1981x-1621y-2082z',
                49:'-1997x-2626y-65z',
                50:'-2069x-1906y-1724z',
                51:'-2079x-1527y-2056z',
                52:'-209x-614y-3235z',
                53:'-2132x-2518y-32z',
                54:'-2174x-1428y-2030z',
                55:'-2179x-1806y-1696z',
                56:'-220x-2209y-2441z',
                57:'-2261x-2403y0z',
                58:'-2263x-1322y-2004z',
                59:'-2284x-1699y-1667z',
                60:'-2347x-1211y-1978z',
                61:'-237x-2534y-2100z',
                62:'-2384x-1587y-1639z',
                63:'-2425x-1095y-1951z',
                64:'-242x-3263y-427z',
                65:'-244x-1107y-3098z',
                66:'-2477x-1468y-1610z',
                67:'-2497x-973y-1924z',
                68:'-253x-632y-3228z',
                69:'-2563x-847y-1898z',
                70:'-2565x-1344y-1581z',
                71:'-2622x-717y-1870z',
                72:'-2646x-1214y-1552z',
                73:'-2674x-583y-1843z',
                74:'-2719x-445y-1816z',
                75:'-2720x-1079y-1523z',
                76:'-2756x-304y-1788z',
                77:'-2787x-940y-1494z',
                78:'-2847x-797y-1464z',
                79:'-2899x-650y-1434z',
                80:'-300x-647y-3221z',
                81:'-309x-1123y-3087z',
                82:'-32x-485y-3263z',
                83:'-339x-2218y-2419z',
                84:'-348x-659y-3214z',
                85:'-372x-2539y-2074z',
                86:'-378x-1134y-3075z',
                87:'-399x-667y-3206z',
                88:'-413x-3250y-394z',
                89:'-448x-1142y-3063z',
                90:'-451x-672y-3199z',
                91:'-460x-2221y-2396z',
                92:'-505x-673y-3190z',
                93:'-509x-2536y-2048z',
                94:'-519x-1144y-3051z',
                95:'-560x-670y-3182z',
                96:'-581x-2217y-2373z',
                97:'-584x-3227y-361z',
                98:'-593x-1143y-3038z',
                99:'-616x-663y-3173z',
                100:'-62x-515y-3258z',
                101:'-646x-2525y-2022z',
                102:'-667x-1136y-3025z',
                103:'-672x-652y-3164z',
                104:'-6x-453y-3268z',
                105:'-704x-2206y-2350z',
                106:'-71x-3266y-460z',
                107:'-729x-637y-3154z',
                108:'-742x-1125y-3011z',
                109:'-752x-3196y-328z',
                110:'-783x-2507y-1996z',
                111:'-786x-617y-3144z',
                112:'-818x-1109y-2998z',
                113:'-826x-2188y-2327z',
                114:'-843x-593y-3134z',
                115:'-894x-1087y-2984z',
                116:'-900x-565y-3124z',
                117:'-920x-2481y-1970z',
                118:'-920x-3155y-296z',
                119:'-949x-2163y-2303z',
                120:'-94x-543y-3253z',
                121:'-955x-532y-3113z',
                122:'-970x-1061y-2970z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3300eight4xi" usage = "target function for charge3300eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3300eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3300EIGHT4XI - STARTED TIME: ", time2start) 
        # 00:58:26 09/07/10 Pacific Daylight Time 
        
        print("\n (STEP 1A2/33) OF FIRE3300EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        #  (STEP 1A2/33) OF FIRE3300EIGHT4XI -  QUEUE2EIGHT:  <queue4xi.Queue4Xi object at 0x0409BF70>

        
        print("\n (STEP 1A3/33) OF FIRE3300EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # (STEP 1A3/33) OF FIRE3300EIGHT4XI -  CONSUMER_CHANNEL2EIGHT:  <read-write PipeConnection, handle 312> 
              
        print("\n (STEP 1A4/33) OF FIRE3300EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # (STEP 1A4/33) OF FIRE3300EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT:  <read-write PipeConnection, handle 316>  
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3300EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight33004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3300EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT:  <queue4xi.Queue4Xi object at 0x0409BF70>  - TIME:  00:58:26 09/07/10 Pacific Daylight Time 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3300EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3300EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight33004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight33004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3300EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2eight8shot2eight33004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2EIGHT:  <read-write PipeConnection, handle 316>  - TIME:  00:58:26 09/07/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE3300EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3300EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # RETURNING QUEUE OBJECT QUEUE2EIGHT:  <queue4xi.Queue4Xi object at 0x0409BF70>  - TIME:  00:58:26 09/07/10 Pacific Daylight Time
            
    return queue2eight    
        
           
#</function4xi>

 
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3300eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

                                  